scala.collection.parallel.mutable

# ParArray

#### class ParArray[T] extends ParSeq[T] with GenericParTemplate[T, ParArray] with ParSeqLike[T, ParArray[T], ArraySeq[T]] with Serializable

Parallel sequence holding elements in a linear array.

`ParArray` is a parallel sequence with a predefined size. The size of the array cannot be changed after it's been created.

`ParArray` internally keeps an array containing the elements. This means that bulk operations based on traversal ensure fast access to elements. `ParArray` uses lazy builders that create the internal data array only after the size of the array is known. In the meantime, they keep the result set fragmented. The fragments are copied into the resulting data array in parallel using fast array copy operations once all the combiners are populated in parallel.

T

  type of the elements in the array

Self Type
  ParArray[T]
Annotations
  @SerialVersionUID( uid = 1L )
Source
  ParArray.scala

Linear Supertypes
Serializable, Serializable, ParSeq[T], ParSeq[T], ParSeqLike[T, ParArray[T], ArraySeq[T]], ParIterable[T], ParIterable[T], ParIterableLike[T, ParArray[T], ArraySeq[T]], Parallel, CustomParallelizable[T, ParArray[T]], GenericParTemplate[T, ParArray], HasNewCombiner[T, ParArray[T]], GenSeq[T], GenIterable[T], GenTraversable[T], GenericTraversableTemplate[T, ParArray], HasNewBuilder[T, ParArray[T]], GenSeqLike[T, ParArray[T]], Equals, GenIterableLike[T, ParArray[T]], GenTraversableLike[T, ParArray[T]], Parallelizable[T, ParArray[T]], GenTraversableOnce[T], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ParArray
2. Serializable
3. Serializable
4. ParSeq
5. ParSeq
6. ParSeqLike
7. ParIterable
8. ParIterable
9. ParIterableLike
10. Parallel
11. CustomParallelizable
12. GenericParTemplate
13. HasNewCombiner
14. GenSeq
15. GenIterable
16. GenTraversable
17. GenericTraversableTemplate
18. HasNewBuilder
19. GenSeqLike
20. Equals
21. GenIterableLike
22. GenTraversableLike
23. Parallelizable
24. GenTraversableOnce
25. AnyRef
26. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ParArray(sz: Int)

### Type Members

1. #### trait Accessor[R, Tp] extends Accessor[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

2. #### class Aggregate[S] extends Accessor[S, Aggregate[S]]

   Attributes
     protected[this]

3. #### trait BuilderOps[Elem, To] extends AnyRef

4. #### class Collect[S, That] extends Transformer[Combiner[S, That], Collect[S, That]]

   Attributes
     protected[this]

5. #### abstract class Composite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]

   Attributes
     protected[this]

6. #### class Copy[U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]

   Attributes
     protected

7. #### class CopyToArray[U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]

   Attributes
     protected[this]

8. #### class Corresponds[S] extends Accessor[Boolean, Corresponds[S]]

   Attributes
     protected[this]

9. #### class Count extends Accessor[Int, Count]

   Attributes
     protected[this]

10. #### class CreateScanTree[U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]

    Attributes
      protected[this]

11. #### class Drop[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]

    Attributes
      protected[this]

12. #### abstract class Elements extends ParIterator with BufferedIterator[T]

    Used to iterate elements using indices

13. #### class Exists extends Accessor[Boolean, Exists]

    Attributes
      protected[this]

14. #### class Filter[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]

    Attributes
      protected[this]

15. #### class FilterNot[U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]

    Attributes
      protected[this]

16. #### class Find[U >: T] extends Accessor[Option[U], Find[U]]

    Attributes
      protected[this]

17. #### class FlatMap[S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]

    Attributes
      protected[this]

18. #### class Fold[U >: T] extends Accessor[U, Fold[U]]

    Attributes
      protected[this]

19. #### class Forall extends Accessor[Boolean, Forall]

    Attributes
      protected[this]

20. #### class Foreach[S] extends Accessor[Unit, Foreach[S]]

    Attributes
      protected[this]

21. #### class FromScanTree[U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]

    Attributes
      protected[this]

22. #### class GroupBy[K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]

    Attributes
      protected[this]

23. #### class IndexWhere extends Accessor[Int, IndexWhere]

    Attributes
      protected[this]

24. #### class LastIndexWhere extends Accessor[Int, LastIndexWhere]

    Attributes
      protected[this]

25. #### class Map[S] extends Task[Unit, Map[S]]

    Definition Classes
      ParArray → ParIterableLike

26. #### class Max[U >: T] extends Accessor[Option[U], Max[U]]

    Attributes
      protected[this]

27. #### class Min[U >: T] extends Accessor[Option[U], Min[U]]

    Attributes
      protected[this]

28. #### trait NonDivisible[R] extends NonDivisibleTask[R, NonDivisible[R]]

    Attributes
      protected[this]

29. #### trait NonDivisibleTask[R, Tp] extends StrictSplitterCheckTask[R, Tp]

    Attributes
      protected[this]

30. #### class ParArrayIterator extends ParIterator

31. #### abstract class ParComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

32. #### trait ParIterator extends SeqSplitter[T] with ParIterator

    An iterator that can be split into arbitrary subsets of iterators.

33. #### class Partition[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]

    Attributes
      protected[this]

34. #### class Product[U >: T] extends Accessor[U, Product[U]]

    Attributes
      protected[this]

35. #### class Reduce[U >: T] extends Accessor[Option[U], Reduce[U]]

    Attributes
      protected[this]

36. #### abstract class ResultMapping[R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]

    Attributes
      protected[this]

37. #### class Reverse[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Reverse[U, This]]

    Attributes
      protected[this]

38. #### class ReverseMap[S, That] extends Transformer[Combiner[S, That], ReverseMap[S, That]]

    Attributes
      protected[this]

39. #### type SCPI = SignalContextPassingIterator[ParArrayIterator]

40. #### type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]

    Definition Classes
      ParIterableLike

41. #### class SameElements[U >: T] extends Accessor[Boolean, SameElements[U]]

    Attributes
      protected[this]

42. #### case class ScanLeaf[U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

43. #### case class ScanNode[U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

44. #### class ScanToArray[U >: T] extends Task[Unit, ScanToArray[U]]

45. #### trait ScanTree[U >: T] extends AnyRef

    Attributes
      protected[this]

46. #### class SegmentLength extends Accessor[(Int, Boolean), SegmentLength]

    Attributes
      protected[this]

47. #### abstract class SeqComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

48. #### trait SignalContextPassingIterator[+IterRepr <: ParIterator] extends ParIterator with SignalContextPassingIterator[IterRepr]

    A stackable modification that ensures signal contexts get passed along the iterators.

49. #### trait SignallingOps[PI <: DelegatedSignalling] extends AnyRef

50. #### class Slice[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]

    Attributes
      protected[this]

51. #### class Span[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]

    Attributes
      protected[this]

52. #### class SplitAt[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]

    Attributes
      protected[this]

53. #### trait StrictSplitterCheckTask[R, Tp] extends Task[R, Tp]

    Attributes
      protected

54. #### class Sum[U >: T] extends Accessor[U, Sum[U]]

    Attributes
      protected[this]

55. #### type SuperParIterator = IterableSplitter[T]

    Definition Classes
      ParSeqLike

56. #### class Take[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]

    Attributes
      protected[this]

57. #### class TakeWhile[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]

    Attributes
      protected[this]

58. #### trait TaskOps[R, Tp] extends AnyRef

59. #### class ToParCollection[U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]

    Attributes
      protected[this]

60. #### class ToParMap[K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]

    Attributes
      protected[this]

61. #### trait Transformer[R, Tp] extends Accessor[R, Tp] with Transformer[R, Tp]

    Attributes
      protected
    Definition Classes
      ParSeqLike → ParIterableLike

62. #### class Updated[U >: T, That] extends Transformer[Combiner[U, That], Updated[U, That]]

    Attributes
      protected[this]

63. #### class Zip[U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike → ParIterableLike

64. #### class ZipAll[U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]

    Attributes
      protected[this]

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### abstract def ++[B](that: GenTraversableOnce[B]): ParArray[B]

   [use case] Returns a new parallel array containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new parallel array containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the parallel array is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this parallel array followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

5. #### def ++[U >: T, That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

   Returns a new parallel array containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new parallel array containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the parallel array is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this parallel array followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike

6. #### abstract def +:(elem: T): ParArray[T]

   [use case] A copy of the parallel array with an element prepended.

   [use case]

   A copy of the parallel array with an element prepended.

   elem

     the prepended element

   returns

     a new collection of type `That` consisting of `elem` followed by all elements of this parallel array .

   Definition Classes
     GenSeqLike

7. #### def +:[U >: T, That](elem: U)(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

   A copy of the parallel array with an element prepended.

   A copy of the parallel array with an element prepended.

   Note that :-ending operators are right associative (see example). Also, the original parallel array is not modified, so you will want to capture the result.

   Example:

            scala> val x = LinkedList(1)
            x: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

            scala> val y = 2 +: x
            y: scala.collection.mutable.LinkedList[Int] = LinkedList(2, 1)

            scala> println(x)
            LinkedList(1)

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   elem

     the prepended element

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` consisting of `elem` followed by all elements of this parallel array .

   Definition Classes
     ParSeqLike → GenSeqLike

8. #### def /:[S](z: S)(op: (S, T) ⇒ S): S

   Applies a binary operator to a start value and all elements of this parallel array , going left to right.

   Applies a binary operator to a start value and all elements of this parallel array , going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this parallel array , going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this parallel array .

   Definition Classes
     ParIterableLike → GenTraversableOnce

9. #### def /:\[A1 >: T](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a /:\ 5)(_+_)
            b: Int = 15

   Definition Classes
     GenTraversableOnce

10. #### abstract def :+(elem: T): ParArray[T]

    [use case] A copy of this parallel array with an element appended.

    [use case]

    A copy of this parallel array with an element appended.

    elem

      the appended element

    returns

      a new collection of type `That` consisting of all elements of this parallel array followed by `elem`.

    Definition Classes
      GenSeqLike

11. #### def :+[U >: T, That](elem: U)(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

    A copy of this parallel array with an element appended.

    A copy of this parallel array with an element appended.

    Note: will not terminate for infinite-sized collections.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    elem

      the appended element

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` consisting of all elements of this parallel array followed by `elem`.

    Definition Classes
      ParSeqLike → GenSeqLike

12. #### def :\[S](z: S)(op: (T, S) ⇒ S): S

    Applies a binary operator to all elements of this parallel array and a start value, going right to left.

    Applies a binary operator to all elements of this parallel array and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this parallel array , going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this parallel array .

    Definition Classes
      ParIterableLike → GenTraversableOnce

13. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

15. #### def aggregate[S](z: S)(seqop: (S, T) ⇒ S, combop: (S, S) ⇒ S): S

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    S

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      ParIterableLike → GenTraversableOnce

16. #### def apply(i: Int): T

    Selects an element by its index in the parallel array .

    Selects an element by its index in the parallel array .

    Example:

           scala> val x = LinkedList(1, 2, 3, 4, 5)
           x: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4, 5)

           scala> x(3)
           res1: Int = 4

    returns

      the element of this parallel array at index `idx`, where `0` indicates the first element.

    Definition Classes
      ParArray → ParSeq → GenSeqLike
    Exceptions thrown
      `IndexOutOfBoundsException`

      if `idx` does not satisfy `0 <= idx < length`.

17. #### val arrayseq: ArraySeq[T]

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### def bf2seq[S, That](bf: CanBuildFrom[ParArray[T], S, That]): CanBuildFrom[ArraySeq[T], S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

20. #### implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]

    Attributes
      protected
    Definition Classes
      ParIterableLike

21. #### def canEqual(other: Any): Boolean

    Definition Classes
      ParIterableLike

22. #### def cbfactory: () ⇒ Combiner[T, ParArray[T]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

23. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

24. #### abstract def collect[B](pf: PartialFunction[T, B]): ParArray[B]

    [use case] Builds a new collection by applying a partial function to all elements of this parallel array

    [use case]

    Builds a new collection by applying a partial function to all elements of this parallel array

    on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the parallel array .

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

25. #### def collect[S, That](pf: PartialFunction[T, S])(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

    Builds a new collection by applying a partial function to all elements of this parallel array

    Builds a new collection by applying a partial function to all elements of this parallel array

    on which the function is defined.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the parallel array .

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

26. #### def companion: GenericCompanion[ParArray] with GenericParCompanion[ParArray]

    The factory companion object that builds instances of class ParArray.

    The factory companion object that builds instances of class ParArray. (or its `Iterable` superclass where class ParArray is not a `Seq`.)

    Definition Classes
      ParArray → ParSeq → ParSeq → ParIterable → ParIterable → GenericParTemplate → GenSeq → GenIterable → GenTraversable → GenericTraversableTemplate

27. #### def copyToArray[U >: T](xs: Array[U], start: Int, len: Int): Unit

    Definition Classes
      ParIterableLike → GenTraversableOnce

28. #### abstract def copyToArray(xs: Array[T], start: Int): Unit

    [use case] Copies values of this parallel array to an array.

    [use case]

    Copies values of this parallel array to an array. Fills the given array `xs` with values of this parallel array , beginning at index `start`. Copying will stop once either the end of the current parallel array is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

29. #### def copyToArray[U >: T](xs: Array[U], start: Int): Unit

    Copies values of this parallel array to an array.

    Copies values of this parallel array to an array. Fills the given array `xs` with values of this parallel array , beginning at index `start`. Copying will stop once either the end of the current parallel array is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce

30. #### abstract def copyToArray(xs: Array[T]): Unit

    [use case] Copies values of this parallel array to an array.

    [use case]

    Copies values of this parallel array to an array. Fills the given array `xs` with values of this parallel array . Copying will stop once either the end of the current parallel array is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

31. #### def copyToArray[U >: T](xs: Array[U]): Unit

    Copies values of this parallel array to an array.

    Copies values of this parallel array to an array. Fills the given array `xs` with values of this parallel array . Copying will stop once either the end of the current parallel array is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce

32. #### def corresponds[S](that: GenSeq[S])(p: (T, S) ⇒ Boolean): Boolean

    Tests whether every element of this parallel array relates to the corresponding element of another parallel sequence by satisfying a test predicate.

    Tests whether every element of this parallel array relates to the corresponding element of another parallel sequence by satisfying a test predicate.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    S

      the type of the elements of `that`

    that

      the other parallel sequence

    p

      the test predicate, which relates elements from both sequences

    returns

      `true` if both parallel sequences have the same length and `p(x, y)` is `true` for all corresponding elements `x` of this parallel array

      and `y` of `that`, otherwise `false`

    Definition Classes
      ParSeqLike → GenSeqLike

33. #### def count(p: (T) ⇒ Boolean): Int

    Counts the number of elements in the parallel array which satisfy a predicate.

    Counts the number of elements in the parallel array which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

34. #### def debugBuffer: ArrayBuffer[String]

    Definition Classes
      ParIterableLike

35. #### implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]

    Attributes
      protected
    Definition Classes
      ParIterableLike

36. #### abstract def diff(that: GenSeq[T]): ParArray[T]

    [use case] Computes the multiset difference between this parallel array and another sequence.

    [use case]

    Computes the multiset difference between this parallel array and another sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this parallel array

      except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      GenSeqLike

37. #### def diff[U >: T](that: GenSeq[U]): ParArray[T]

    Computes the multiset difference between this parallel array and another sequence.

    Computes the multiset difference between this parallel array and another sequence.

    Note: will not terminate for infinite-sized collections.

    that

      the sequence of elements to remove

    returns

      a new collection of type `That` which contains all elements of this parallel array

      except some of occurrences of elements that also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will not form part of the result, but any following occurrences will.

    Definition Classes
      ParSeqLike → GenSeqLike

38. #### def distinct: ParArray[T]

    Builds a new parallel array from this parallel array without any duplicate elements.

    Builds a new parallel array from this parallel array without any duplicate elements.

    Note: will not terminate for infinite-sized collections.

    returns

      A new parallel array which contains the first occurrence of every element of this parallel array .

    Definition Classes
      ParSeqLike → GenSeqLike

39. #### def down(p: scala.collection.parallel.IterableSplitter[_]): SeqSplitter[T]

    Attributes
      protected[this]
    Definition Classes
      ParSeqLike

40. #### def drop(n: Int): ParArray[T]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this parallel array .

    returns

      a parallel array consisting of all elements of this parallel array except the first `n` ones, or else the empty parallel array , if this parallel array has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

41. #### def dropWhile(pred: (T) ⇒ Boolean): ParArray[T]

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this parallel array that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

42. #### def endsWith[S](that: GenSeq[S]): Boolean

    Tests whether this parallel array ends with the given parallel sequence.

    Tests whether this parallel array ends with the given parallel sequence.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    S

      the type of the elements of `that` sequence

    that

      the sequence to test

    returns

      `true` if this parallel array has `that` as a suffix, `false` otherwise

    Definition Classes
      ParSeqLike → GenSeqLike

43. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

44. #### def equals(that: Any): Boolean

    The equals method for arbitrary sequences.

    The equals method for arbitrary sequences. Compares this sequence to some other object.

    that

      The object to compare the sequence to

    returns

      `true` if `that` is a sequence that has the same elements as this sequence in the same order, `false` otherwise

    Definition Classes
      GenSeqLike → Equals → AnyRef → Any

45. #### def exists(pred: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this parallel array .

    Tests whether a predicate holds for some element of this parallel array .

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

46. #### def filter(pred: (T) ⇒ Boolean): ParArray[T]

    Selects all elements of this parallel array which satisfy a predicate.

    Selects all elements of this parallel array which satisfy a predicate.

    returns

      a new parallel array consisting of all elements of this parallel array that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

47. #### def filterNot(pred: (T) ⇒ Boolean): ParArray[T]

    Selects all elements of this parallel array which do not satisfy a predicate.

    Selects all elements of this parallel array which do not satisfy a predicate.

    returns

      a new parallel array consisting of all elements of this parallel array that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

48. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

49. #### def find(pred: (T) ⇒ Boolean): Option[T]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

50. #### abstract def flatMap[B](f: (T) ⇒ GenTraversableOnce[B]): ParArray[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel array

    [use case]

    Builds a new collection by applying a function to all elements of this parallel array

    and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this parallel array and concatenating the results.

    Definition Classes
      GenTraversableLike

51. #### def flatMap[S, That](f: (T) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

    Builds a new collection by applying a function to all elements of this parallel array

    Builds a new collection by applying a function to all elements of this parallel array

    and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of parallel array . This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this parallel array and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike

52. #### abstract def flatten[B]: ParArray[B]

    [use case] Converts this parallel array of traversable collections into a parallel array formed by the elements of these traversable collections.

    [use case]

    Converts this parallel array of traversable collections into a parallel array formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new parallel array resulting from concatenating all element parallel array s.

    Definition Classes
      GenericTraversableTemplate

53. #### def flatten[B](implicit asTraversable: (T) ⇒ TraversableOnce[B]): ParArray[B]

    Converts this parallel array of traversable collections into a parallel array formed by the elements of these traversable collections.

    Converts this parallel array of traversable collections into a parallel array formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of parallel array . For example:

         val xs = List(Set(1, 2, 3), Set(1, 2, 3))
         // xs == List(1, 2, 3, 1, 2, 3)

         val ys = Set(List(1, 2, 3), List(3, 2, 1))
         // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this parallel array is a `Traversable`.

    returns

      a new parallel array resulting from concatenating all element parallel array s.

    Definition Classes
      GenericTraversableTemplate

54. #### def fold[U >: T](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce

55. #### def foldLeft[S](z: S)(op: (S, T) ⇒ S): S

    Applies a binary operator to a start value and all elements of this parallel array , going left to right.

    Applies a binary operator to a start value and all elements of this parallel array , going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel array , going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this parallel array .

    Definition Classes
      ParIterableLike → GenTraversableOnce

56. #### def foldRight[S](z: S)(op: (T, S) ⇒ S): S

    Applies a binary operator to all elements of this parallel array and a start value, going right to left.

    Applies a binary operator to all elements of this parallel array and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this parallel array , going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this parallel array .

    Definition Classes
      ParIterableLike → GenTraversableOnce

57. #### def forall(pred: (T) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this parallel array .

    Tests whether a predicate holds for all elements of this parallel array .

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

58. #### def foreach[U](f: (T) ⇒ U): Unit

    Applies a function `f` to all the elements of parallel array in a sequential order.

    Applies a function `f` to all the elements of parallel array in a sequential order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

59. #### def genericBuilder[B]: Combiner[B, ParArray[B]]

    The generic builder that builds instances of ParArray at arbitrary element types.

    The generic builder that builds instances of ParArray at arbitrary element types.

    Definition Classes
      GenericParTemplate → GenericTraversableTemplate

60. #### def genericCombiner[B]: Combiner[B, ParArray[B]]

    Definition Classes
      GenericParTemplate

61. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

62. #### def groupBy[K](f: (T) ⇒ K): ParMap[K, ParArray[T]]

    Partitions this parallel array into a map of parallel array s according to some discriminator function.

    Partitions this parallel array into a map of parallel array s according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new parallel array .

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to parallel array s such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a parallel array of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike

63. #### def hasDefiniteSize: Boolean

    Definition Classes
      ParIterableLike → GenTraversableOnce

64. #### def hashCode(): Int

    Hashcodes for ParArray produce a value from the hashcodes of all the elements of the parallel array .

    Hashcodes for ParArray produce a value from the hashcodes of all the elements of the parallel array .

    returns

      the hash code value for this object.

    Definition Classes
      GenSeqLike → AnyRef → Any

65. #### def head: T

    Definition Classes
      GenIterableLike → GenTraversableLike

66. #### abstract def indexOf(elem: T, from: Int): Int

    [use case] Finds index of first occurrence of some value in this parallel array after or at some start index.

    [use case]

    Finds index of first occurrence of some value in this parallel array after or at some start index.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

67. #### def indexOf[B >: T](elem: B, from: Int): Int

    Finds index of first occurrence of some value in this parallel array after or at some start index.

    Finds index of first occurrence of some value in this parallel array after or at some start index.

    Note: may not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    from

      the start index

    returns

      the index `>= from` of the first element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

68. #### abstract def indexOf(elem: T): Int

    [use case] Finds index of first occurrence of some value in this parallel array .

    [use case]

    Finds index of first occurrence of some value in this parallel array .

    elem

      the element value to search for.

    returns

      the index of the first element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

69. #### def indexOf[B >: T](elem: B): Int

    Finds index of first occurrence of some value in this parallel array .

    Finds index of first occurrence of some value in this parallel array .

    Note: may not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the first element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

70. #### def indexWhere(p: (T) ⇒ Boolean, from: Int): Int

    Finds the first element satisfying some predicate.

    Finds the first element satisfying some predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

    The index flag is initially set to maximum integer value.

    p

      the predicate used to test the elements

    from

      the starting offset for the search

    returns

      the index `>= from` of the first element of this parallel array that satisfies the predicate `p`, or `-1`, if none exists

    Definition Classes
      ParSeqLike → GenSeqLike

71. #### def indexWhere(p: (T) ⇒ Boolean): Int

    Finds index of first element satisfying some predicate.

    Finds index of first element satisfying some predicate.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the first element of this parallel array that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

72. #### abstract def intersect(that: Seq[T]): ParArray[T]

    [use case] Computes the multiset intersection between this parallel array and another sequence.

    [use case]

    Computes the multiset intersection between this parallel array and another sequence.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this parallel array

      which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      ParSeqLike

73. #### def intersect[U >: T](that: GenSeq[U]): ParArray[T]

    Computes the multiset intersection between this parallel array and another sequence.

    Computes the multiset intersection between this parallel array and another sequence.

    Note: may not terminate for infinite-sized collections.

    that

      the sequence of elements to intersect with.

    returns

      a new collection of type `That` which contains all elements of this parallel array

      which also appear in `that`. If an element value `x` appears n times in `that`, then the first n occurrences of `x` will be retained in the result, but any following occurrences will be omitted.

    Definition Classes
      ParSeqLike → GenSeqLike

74. #### def isDefinedAt(idx: Int): Boolean

    Tests whether this parallel array contains given index.

    Tests whether this parallel array contains given index.

    The implementations of methods `apply` and `isDefinedAt` turn a `Seq[A]` into a `PartialFunction[Int, A]`.

    idx

      the index to test

    returns

      `true` if this parallel array contains an element at position `idx`, `false` otherwise.

    Definition Classes
      GenSeqLike

75. #### def isEmpty: Boolean

    Tests whether the parallel array is empty.

    Tests whether the parallel array is empty.

    returns

      `true` if the parallel array contains no elements, `false` otherwise.

    Definition Classes
      GenIterableLike → GenTraversableOnce

76. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

77. #### def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

    Definition Classes
      ParIterableLike

78. #### final def isTraversableAgain: Boolean

    Tests whether this parallel array can be repeatedly traversed.

    Tests whether this parallel array can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

79. #### def iterator: PreciseSplitter[T]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParSeqLike → ParIterableLike → GenIterableLike

80. #### abstract def lastIndexOf(elem: T, end: Int): Int

    [use case] Finds index of last occurrence of some value in this parallel array before or at a given end index.

    [use case]

    Finds index of last occurrence of some value in this parallel array before or at a given end index.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

81. #### def lastIndexOf[B >: T](elem: B, end: Int): Int

    Finds index of last occurrence of some value in this parallel array before or at a given end index.

    Finds index of last occurrence of some value in this parallel array before or at a given end index.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    end

      the end index.

    returns

      the index `<= end` of the last element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

82. #### abstract def lastIndexOf(elem: T): Int

    [use case] Finds index of last occurrence of some value in this parallel array .

    [use case]

    Finds index of last occurrence of some value in this parallel array .

    elem

      the element value to search for.

    returns

      the index of the last element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

83. #### def lastIndexOf[B >: T](elem: B): Int

    Finds index of last occurrence of some value in this parallel array .

    Finds index of last occurrence of some value in this parallel array .

    Note: will not terminate for infinite-sized collections.

    B

      the type of the element `elem`.

    elem

      the element value to search for.

    returns

      the index of the last element of this parallel array that is equal (wrt `==`) to `elem`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

84. #### def lastIndexWhere(p: (T) ⇒ Boolean, end: Int): Int

    Finds the last element satisfying some predicate.

    Finds the last element satisfying some predicate.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

    The index flag is initially set to minimum integer value.

    p

      the predicate used to test the elements

    end

      the maximum offset for the search

    returns

      the index `<= end` of the first element of this parallel array that satisfies the predicate `p`, or `-1`, if none exists

    Definition Classes
      ParSeqLike → GenSeqLike

85. #### def lastIndexWhere(p: (T) ⇒ Boolean): Int

    Finds index of last element satisfying some predicate.

    Finds index of last element satisfying some predicate.

    Note: will not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      the index of the last element of this parallel array that satisfies the predicate `p`, or `-1`, if none exists.

    Definition Classes
      GenSeqLike

86. #### def length: Int

    The length of the parallel array .

    The length of the parallel array .

    Note: will not terminate for infinite-sized collections.

    Note: `xs.length` and `xs.size` yield the same result.

    returns

      the number of elements in this parallel array .

    Definition Classes
      ParArray → GenSeqLike

87. #### abstract def map[B](f: (T) ⇒ B): ParArray[B]

    [use case] Builds a new collection by applying a function to all elements of this parallel array .

    [use case]

    Builds a new collection by applying a function to all elements of this parallel array .

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this parallel array and collecting the results.

    Definition Classes
      GenTraversableLike

88. #### def map[S, That](f: (T) ⇒ S)(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

    Builds a new collection by applying a function to all elements of this parallel array .

    Builds a new collection by applying a function to all elements of this parallel array .

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this parallel array and collecting the results.

    Definition Classes
      ParArray → ParIterableLike → GenTraversableLike

89. #### abstract def max: T

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this parallel array with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

90. #### def max[U >: T](implicit ord: Ordering[U]): T

    Finds the largest element.

    Finds the largest element.

    returns

      the largest element of this parallel array with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

91. #### def maxBy[S](f: (T) ⇒ S)(implicit cmp: Ordering[S]): T

    Definition Classes
      ParIterableLike → GenTraversableOnce

92. #### abstract def min: T

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this parallel array with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

93. #### def min[U >: T](implicit ord: Ordering[U]): T

    Finds the smallest element.

    Finds the smallest element.

    returns

      the smallest element of this parallel array with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

94. #### def minBy[S](f: (T) ⇒ S)(implicit cmp: Ordering[S]): T

    Definition Classes
      ParIterableLike → GenTraversableOnce

95. #### def mkString: String

    Displays all elements of this parallel array in a string.

    Displays all elements of this parallel array in a string.

    returns

      a string representation of this parallel array . In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel array follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce

96. #### def mkString(sep: String): String

    Displays all elements of this parallel array in a string using a separator string.

    Displays all elements of this parallel array in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this parallel array . In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this parallel array are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

97. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this parallel array in a string using start, end, and separator strings.

    Displays all elements of this parallel array in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this parallel array . The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this parallel array are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

98. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

99. #### def newBuilder: Builder[T, ParArray[T]]

    The builder that builds instances of type ParArray[A]

    The builder that builds instances of type ParArray[A]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → GenericTraversableTemplate → HasNewBuilder

100. #### def newCombiner: Combiner[T, ParArray[T]]

     Attributes
       protected[this]
     Definition Classes
       GenericParTemplate → HasNewCombiner

101. #### def nonEmpty: Boolean

     Tests whether the parallel array is not empty.

     Tests whether the parallel array is not empty.

     returns

       `true` if the parallel array contains at least one element, `false` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

102. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

103. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

104. #### abstract def padTo(len: Int, elem: T): ParArray[T]

     [use case] A copy of this parallel array with an element value appended until a given target length is reached.

     [use case]

     A copy of this parallel array with an element value appended until a given target length is reached.

     len

       the target length

     elem

       the padding value

     returns

       a new collection of type `That` consisting of all elements of this parallel array followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       GenSeqLike

105. #### def padTo[U >: T, That](len: Int, elem: U)(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

     A copy of this parallel array with an element value appended until a given target length is reached.

     A copy of this parallel array with an element value appended until a given target length is reached.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     len

       the target length

     elem

       the padding value

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       a new collection of type `That` consisting of all elements of this parallel array followed by the minimal number of occurrences of `elem` so that the resulting collection has a length of at least `len`.

     Definition Classes
       ParSeqLike → GenSeqLike

106. #### def par: ParArray[T]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       ParIterableLike → CustomParallelizable → Parallelizable

107. #### def parCombiner: Combiner[T, ParArray[T]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       CustomParallelizable → Parallelizable

108. #### def partition(pred: (T) ⇒ Boolean): (ParArray[T], ParArray[T])

     Partitions this parallel array in two parallel array s according to a predicate.

     Partitions this parallel array in two parallel array s according to a predicate.

     returns

       a pair of parallel array s: the first parallel array consists of all elements that satisfy the predicate `p` and the second parallel array consists of all elements that don't. The relative order of the elements in the resulting parallel array s may not be preserved.

     Definition Classes
       ParIterableLike → GenTraversableLike

109. #### abstract def patch(from: Int, that: GenSeq[T], replaced: Int): ParArray[T]

     [use case] Produces a new parallel array where a slice of elements in this parallel array is replaced by another sequence.

     [use case]

     Produces a new parallel array where a slice of elements in this parallel array is replaced by another sequence.

     from

       the index of the first replaced element

     replaced

       the number of elements to drop in the original parallel array

     returns

       a new parallel array consisting of all elements of this parallel array

       except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       GenSeqLike

110. #### def patch[U >: T, That](from: Int, patch: GenSeq[U], replaced: Int)(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

     Produces a new parallel array where a slice of elements in this parallel array is replaced by another sequence.

     Produces a new parallel array where a slice of elements in this parallel array is replaced by another sequence.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     from

       the index of the first replaced element

     patch

       the replacement sequence

     replaced

       the number of elements to drop in the original parallel array

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       a new parallel array consisting of all elements of this parallel array

       except that `replaced` elements starting from `from` are replaced by `patch`.

     Definition Classes
       ParSeqLike → GenSeqLike

111. #### def prefixLength(p: (T) ⇒ Boolean): Int

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Returns the length of the longest prefix whose elements all satisfy some predicate.

     Note: may not terminate for infinite-sized collections.

     p

       the predicate used to test elements.

     returns

       the length of the longest prefix of this parallel array

       such that every element of the segment satisfies the predicate `p`.

     Definition Classes
       GenSeqLike

112. #### abstract def product: T

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements of this parallel array with respect to the `*` operator in `num`.

     Definition Classes
       GenTraversableOnce

113. #### def product[U >: T](implicit num: Numeric[U]): U

     Multiplies up the elements of this collection.

     Multiplies up the elements of this collection.

     num

       an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

     returns

       the product of all elements of this parallel array with respect to the `*` operator in `num`.

     Definition Classes
       ParIterableLike → GenTraversableOnce

114. #### def reduce[U >: T](op: (U, U) ⇒ U): U

     Reduces the elements of this sequence using the specified associative binary operator.

     Reduces the elements of this sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

     U

       A type parameter for the binary operator, a supertype of `T`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the collection is nonempty.

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Exceptions thrown
       UnsupportedOperationException

       if this parallel array is empty.

115. #### def reduceLeft[U >: T](op: (U, T) ⇒ U): U

     Definition Classes
       ParIterableLike

116. #### def reduceLeftOption[U >: T](op: (U, T) ⇒ U): Option[U]

     Optionally applies a binary operator to all elements of this parallel array , going left to right.

     Optionally applies a binary operator to all elements of this parallel array , going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this parallel array is nonempty, `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

117. #### def reduceOption[U >: T](op: (U, U) ⇒ U): Option[U]

     Optionally reduces the elements of this sequence using the specified associative binary operator.

     Optionally reduces the elements of this sequence using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

     U

       A type parameter for the binary operator, a supertype of `T`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

118. #### def reduceRight[U >: T](op: (T, U) ⇒ U): U

     Applies a binary operator to all elements of this parallel array , going right to left.

     Applies a binary operator to all elements of this parallel array , going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this parallel array , going right to left:

                       op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

       where `x1, ..., xn` are the elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce
     Exceptions thrown
       `UnsupportedOperationException`

       if this parallel array is empty.

119. #### def reduceRightOption[U >: T](op: (T, U) ⇒ U): Option[U]

     Optionally applies a binary operator to all elements of this parallel array , going right to left.

     Optionally applies a binary operator to all elements of this parallel array , going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this parallel array is nonempty, `None` otherwise.

     Definition Classes
       ParIterableLike → GenTraversableOnce

120. #### def repr: ParArray[T]

     Definition Classes
       ParIterableLike → GenTraversableLike

121. #### def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

     Optionally reuses an existing combiner for better performance.

     Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

     oldc

       The combiner that is the result of the previous task, or `None` if there was no previous task.

     newc

       The new, empty combiner that can be used.

     returns

       Either `newc` or `oldc`.

     Attributes
       protected
     Definition Classes
       ParIterableLike

122. #### def reverse: ParArray[T]

     Returns new parallel array wih elements in reversed order.

     Returns new parallel array wih elements in reversed order.

     Note: will not terminate for infinite-sized collections.

     returns

       A new parallel array with all elements of this parallel array in reversed order.

     Definition Classes
       ParSeqLike → GenSeqLike

123. #### abstract def reverseMap[B](f: (T) ⇒ B): ParArray[B]

     [use case] Builds a new collection by applying a function to all elements of this parallel array and collecting the results in reversed order.

     [use case]

     Builds a new collection by applying a function to all elements of this parallel array and collecting the results in reversed order.

     B

       the element type of the returned collection.

     f

       the function to apply to each element.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this parallel array and collecting the results in reversed order.

       Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     Definition Classes
       GenSeqLike

124. #### def reverseMap[S, That](f: (T) ⇒ S)(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

     Builds a new collection by applying a function to all elements of this parallel array and collecting the results in reversed order.

     Builds a new collection by applying a function to all elements of this parallel array and collecting the results in reversed order.

     Note: will not terminate for infinite-sized collections.

     Note: `xs.reverseMap(f)` is the same as `xs.reverse.map(f)` but might be more efficient.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     f

       the function to apply to each element.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       a new collection of type `That` resulting from applying the given function `f` to each element of this parallel array and collecting the results in reversed order.

     Definition Classes
       ParSeqLike → GenSeqLike

125. #### abstract def sameElements(that: GenIterable[T]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this parallel array .

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this parallel array .

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       GenIterableLike

126. #### def sameElements[U >: T](that: GenIterable[U]): Boolean

     Checks if the other iterable collection contains the same elements in the same order as this parallel array .

     Checks if the other iterable collection contains the same elements in the same order as this parallel array .

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Note: will not terminate for infinite-sized collections.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       ParSeqLike → ParIterableLike → GenIterableLike

127. #### abstract def scan(z: T)(op: (T, T) ⇒ T): ParArray[T]

     [use case] Computes a prefix scan of the elements of the collection.

     [use case]

     Computes a prefix scan of the elements of the collection.

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     returns

       a collection containing the prefix scan of the elements in the original collection

     Definition Classes
       ParIterableLike

128. #### def scan[U >: T, That](z: U)(op: (U, U) ⇒ U)(implicit cbf: CanBuildFrom[ParArray[T], U, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     U

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a collection containing the prefix scan of the elements in the original collection

     Definition Classes
       ParArray → ParIterableLike → GenTraversableLike

129. #### def scanBlockSize: Int

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

130. #### def scanLeft[S, That](z: S)(op: (S, T) ⇒ S)(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

131. #### def scanRight[S, That](z: S)(op: (T, S) ⇒ S)(implicit bf: CanBuildFrom[ParArray[T], S, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

132. #### def segmentLength(p: (T) ⇒ Boolean, from: Int): Int

     Returns the length of the longest segment of elements starting at a given position satisfying some predicate.

     Returns the length of the longest segment of elements starting at a given position satisfying some predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state.

     The index flag is initially set to maximum integer value.

     p

       the predicate used to test the elements

     from

       the starting offset for the search

     returns

       the length of the longest segment of elements starting at `from` and satisfying the predicate

     Definition Classes
       ParSeqLike → GenSeqLike

133. #### def seq: ArraySeq[T]

     Definition Classes
       ParArray → ParSeq → ParIterable → ParIterableLike → GenSeq → GenIterable → GenTraversable → Parallelizable → GenTraversableOnce

134. #### def sequentially[S, That <: Parallel](b: (ArraySeq[T]) ⇒ Parallelizable[S, That]): ParArray[T]

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

135. #### def size: Int

     The size of this parallel array .

     The size of this parallel array .

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this parallel array .

     Definition Classes
       ParSeqLike → GenTraversableLike → GenTraversableOnce

136. #### def slice(unc_from: Int, unc_until: Int): ParArray[T]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a parallel array containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableLike

137. #### def span(pred: (T) ⇒ Boolean): (ParArray[T], ParArray[T])

     Splits this parallel array into a prefix/suffix pair according to a predicate.

     Splits this parallel array into a prefix/suffix pair according to a predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

     Definition Classes
       ParIterableLike → GenTraversableLike

138. #### def splitAt(n: Int): (ParArray[T], ParArray[T])

     Splits this parallel array into two at a given position.

     Splits this parallel array into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of parallel array s consisting of the first `n` elements of this parallel array , and the other elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

139. #### def splitter: ParArrayIterator

     A more refined version of the iterator found in the `ParallelIterable` trait, this iterator can be split into arbitrary subsets of iterators.

     A more refined version of the iterator found in the `ParallelIterable` trait, this iterator can be split into arbitrary subsets of iterators.

     returns

       an iterator that can be split into subsets of precise size

     Attributes
       protected[parallel]
     Definition Classes
       ParArray → ParSeqLike → ParIterableLike

140. #### def startsWith[S](that: GenSeq[S], offset: Int): Boolean

     Tests whether this parallel array contains the given sequence at a given index.

     Tests whether this parallel array contains the given sequence at a given index.

     This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

     that

       the parallel sequence this sequence is being searched for

     offset

       the starting offset for the search

     returns

       `true` if there is a sequence `that` starting at `offset` in this sequence, `false` otherwise

     Definition Classes
       ParSeqLike → GenSeqLike

141. #### def startsWith[B](that: GenSeq[B]): Boolean

     Tests whether this parallel array starts with the given sequence.

     Tests whether this parallel array starts with the given sequence.

     that

       the sequence to test

     returns

       `true` if this collection has `that` as a prefix, `false` otherwise.

     Definition Classes
       GenSeqLike

142. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this parallel array . By default the string prefix is the simple name of the collection class parallel array .

     Definition Classes
       ParSeq → ParIterable → GenTraversableLike

143. #### abstract def sum: T

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this parallel array with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

144. #### def sum[U >: T](implicit num: Numeric[U]): U

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this parallel array with respect to the `+` operator in `num`.

     Definition Classes
       ParIterableLike → GenTraversableOnce

145. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

146. #### def tail: ParArray[T]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a parallel array consisting of all elements of this parallel array

       except the first one.

     Definition Classes
       GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the parallel array is empty.

147. #### def take(n: Int): ParArray[T]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this parallel array .

     returns

       a parallel array consisting only of the first `n` elements of this parallel array , or else the whole parallel array , if it has less than `n` elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

148. #### def takeWhile(pred: (T) ⇒ Boolean): ParArray[T]

     Takes the longest prefix of elements that satisfy the predicate.

     Takes the longest prefix of elements that satisfy the predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       the longest prefix of this parallel array of elements that satisy the predicate `pred`

     Definition Classes
       ParIterableLike → GenTraversableLike

149. #### implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]

     Attributes
       protected
     Definition Classes
       ParIterableLike

150. #### def threshold(sz: Int, p: Int): Int

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     This method depends on the size of the collection and the parallelism level, which are both specified as arguments.

     sz

       the size based on which to compute the threshold

     p

       the parallelism level based on which to compute the threshold

     returns

       the maximum number of elements for performing operations sequentially

     Definition Classes
       ParIterableLike

151. #### abstract def toArray: Array[T]

     [use case] Converts this parallel array to an array.

     [use case]

     Converts this parallel array to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this parallel array .

     Definition Classes
       GenTraversableOnce

152. #### def toArray[U >: T](implicit arg0: ClassManifest[U]): Array[U]

     Converts this parallel array to an array.

     Converts this parallel array to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

153. #### def toBuffer[U >: T]: Buffer[U]

     Converts this parallel array to a mutable buffer.

     Converts this parallel array to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

154. #### def toIndexedSeq[U >: T]: IndexedSeq[U]

     Converts this parallel array to an indexed sequence.

     Converts this parallel array to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

155. #### def toIterable: ParIterable[T]

     Converts this parallel array to an iterable collection.

     Converts this parallel array to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this parallel array .

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

156. #### def toIterator: Iterator[T]

     Returns an Iterator over the elements in this parallel array .

     Returns an Iterator over the elements in this parallel array . Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

157. #### def toList: List[T]

     Converts this parallel array to a list.

     Converts this parallel array to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

158. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this parallel array to a map.

     [use case]

     Converts this parallel array to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this parallel array .

     Definition Classes
       GenTraversableOnce

159. #### def toMap[K, V](implicit ev: <:<[T, (K, V)]): ParMap[K, V]

     Converts this parallel array to a map.

     Converts this parallel array to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

160. #### def toParCollection[U >: T, That](cbf: () ⇒ Combiner[U, That]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

161. #### def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[T, (K, V)]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

162. #### def toSeq: ParSeq[T]

     Converts this parallel array to a sequence.

     Converts this parallel array to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this parallel array .

     Definition Classes
       ParSeq → ParSeqLike → ParIterable → ParIterableLike → GenSeqLike → GenTraversableOnce

163. #### def toSet[U >: T]: ParSet[U]

     Converts this parallel array to a set.

     Converts this parallel array to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

164. #### def toStream: Stream[T]

     Converts this parallel array to a stream.

     Converts this parallel array to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

165. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParSeq → ParSeqLike → ParIterableLike → AnyRef → Any

166. #### def toTraversable: GenTraversable[T]

     Converts this parallel array to an unspecified Traversable.

     Converts this parallel array to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this parallel array .

     Definition Classes
       ParIterableLike → GenTraversableOnce

167. #### def transpose[B](implicit asTraversable: (T) ⇒ GenTraversableOnce[B]): ParArray[ParArray[B]]

     Transposes this parallel array of traversable collections into a parallel array of parallel array s.

     Transposes this parallel array of traversable collections into a parallel array of parallel array s.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this parallel array is a `Traversable`.

     returns

       a two-dimensional parallel array of parallel array s which has as nth row the nth column of this parallel array .

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this parallel array

       are not of the same size.

168. #### abstract def union(that: GenSeq[T]): ParArray[T]

     [use case] Produces a new sequence which contains all elements of this parallel array and also all elements of a given sequence.

     [use case]

     Produces a new sequence which contains all elements of this parallel array and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Note: will not terminate for infinite-sized collections.

     that

       the sequence to add.

     returns

       a new collection of type `That` which contains all elements of this parallel array

       followed by all elements of `that`.

     Definition Classes
       GenSeqLike

169. #### def union[B >: T, That](that: GenSeq[B])(implicit bf: CanBuildFrom[ParArray[T], B, That]): That

     Produces a new sequence which contains all elements of this parallel array and also all elements of a given sequence.

     Produces a new sequence which contains all elements of this parallel array and also all elements of a given sequence. `xs union ys` is equivalent to `xs ++ ys`.

     Note: will not terminate for infinite-sized collections.

     Another way to express this is that `xs union ys` computes the order-presevring multi-set union of `xs` and `ys`. `union` is hence a counter-part of `diff` and `intersect` which also work on multi-sets.

     Note: will not terminate for infinite-sized collections.

     B

       the element type of the returned parallel array .

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     that

       the sequence to add.

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       a new collection of type `That` which contains all elements of this parallel array

       followed by all elements of `that`.

     Definition Classes
       GenSeqLike

170. #### def unzip[A1, A2](implicit asPair: (T) ⇒ (A1, A2)): (ParArray[A1], ParArray[A2])

     Converts this parallel array of pairs into two collections of the first and second half of each pair.

     Converts this parallel array of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this parallel array is a pair.

     returns

       a pair parallel array s, containing the first, respectively second half of each element pair of this parallel array .

     Definition Classes
       GenericTraversableTemplate

171. #### def unzip3[A1, A2, A3](implicit asTriple: (T) ⇒ (A1, A2, A3)): (ParArray[A1], ParArray[A2], ParArray[A3])

     Converts this parallel array of triples into three collections of the first, second, and third element of each triple.

     Converts this parallel array of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this parallel array is a triple.

     returns

       a triple parallel array s, containing the first, second, respectively third member of each element triple of this parallel array .

     Definition Classes
       GenericTraversableTemplate

172. #### def update(i: Int, elem: T): Unit

     Definition Classes
       ParArray → ParSeq

173. #### abstract def updated(index: Int, elem: T): ParArray[T]

     [use case] A copy of this parallel array with one single replaced element.

     [use case]

     A copy of this parallel array with one single replaced element.

     index

       the position of the replacement

     elem

       the replacing element

     returns

       a new parallel array `which is a copy of this parallel array with the element at position` index`replaced by` elem`.`

     Definition Classes
       GenSeqLike

174. #### def updated[U >: T, That](index: Int, elem: U)(implicit bf: CanBuildFrom[ParArray[T], U, That]): That

     A copy of this parallel array with one single replaced element.

     A copy of this parallel array with one single replaced element.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

     index

       the position of the replacement

     elem

       the replacing element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       a new parallel array `which is a copy of this parallel array with the element at position` index`replaced by` elem`.`

     Definition Classes
       ParSeqLike → GenSeqLike

175. #### def view: ParSeqView[T, ParArray[T], ArraySeq[T]]

     Definition Classes
       ParSeqLike → ParIterableLike

176. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

177. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

178. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

179. #### def wrap[R](body: ⇒ R): NonDivisible[R]

     Attributes
       protected
     Definition Classes
       ParIterableLike

180. #### abstract def zip[B](that: GenIterable[B]): ParArray[(T, B)]

     [use case] Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this parallel array and `that`. The length of the returned collection is the minimum of the lengths of this parallel array and `that`.

     Definition Classes
       GenIterableLike

181. #### def zip[U >: T, S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[ParArray[T], (U, S), That]): That

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs.

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this parallel array and `that`. The length of the returned collection is the minimum of the lengths of this parallel array and `that`.

     Definition Classes
       ParSeqLike → ParIterableLike → GenIterableLike

182. #### abstract def zipAll[B](that: Iterable[B], thisElem: T, thatElem: B): ParArray[(T, B)]

     [use case] Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this parallel array is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this parallel array .

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this parallel array and `that`. The length of the returned collection is the maximum of the lengths of this parallel array and `that`. If this parallel array is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this parallel array , `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

183. #### def zipAll[S, U >: T, That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[ParArray[T], (U, S), That]): That

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs.

     Returns a parallel array formed from this parallel array and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this parallel array is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this parallel array .

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this parallel array and `that`. The length of the returned collection is the maximum of the lengths of this parallel array and `that`. If this parallel array is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this parallel array , `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike

184. #### abstract def zipWithIndex: ParArray[(T, Int)]

     [use case] Zips this parallel array with its indices.

     [use case]

     Zips this parallel array with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this parallel array paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

185. #### def zipWithIndex[U >: T, That](implicit bf: CanBuildFrom[ParArray[T], (U, Int), That]): That

     Zips this parallel array with its indices.

     Zips this parallel array with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this parallel array paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike

### Inherited from Serializable

### Inherited from ParSeq[T]

### Inherited from ParSeqLike[T, ParArray[T], ArraySeq[T]]

### Inherited from ParIterable[T]

### Inherited from ParIterableLike[T, ParArray[T], ArraySeq[T]]

### Inherited from Parallel

### Inherited from CustomParallelizable[T, ParArray[T]]

### Inherited from GenericParTemplate[T, ParArray]

### Inherited from HasNewCombiner[T, ParArray[T]]

### Inherited from GenSeq[T]

### Inherited from GenIterable[T]

### Inherited from GenTraversable[T]

### Inherited from GenericTraversableTemplate[T, ParArray]

### Inherited from HasNewBuilder[T, ParArray[T]]

### Inherited from GenSeqLike[T, ParArray[T]]

### Inherited from Equals

### Inherited from GenIterableLike[T, ParArray[T]]

### Inherited from GenTraversableLike[T, ParArray[T]]

### Inherited from Parallelizable[T, ParArray[T]]

### Inherited from GenTraversableOnce[T]

### Inherited from AnyRef

### Inherited from Any